/**
 ** GrupoJugadas.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class GrupoJugadas {

	public int njugadas;
	public Jugada jg[];
	
    GrupoJugadas() {
    	jg = new Jugada[4];
    	njugadas = 0;
    }
    
	public int genera(EstadoPartida mEP, int ncjugador, int nvdado) {
		njugadas = 0;
		/* mira si son tres seises y la nfmovida está en el corredor */
		/* entonces se va a casa */
		if (mEP.nseises == 3 && mEP.nfmovida >= 0 &&
			mEP.pos_ficha[ncjugador][mEP.nfmovida].lugar == Posicion.CORREDOR) {
			jg[0] = new Jugada();
			njugadas = jg[0].genACasa(mEP, ncjugador, mEP.nfmovida, nvdado);
            return njugadas;
		}

		/* mira si es 5 y no ha salido aun, saca dos fichas y es jugada unica */
		if (nvdado == 5 && !mEP.jgha_salido[ncjugador]) {
			jg[0] = new Jugada();
			njugadas = jg[0].genPrimer5(mEP, ncjugador);
			return njugadas;
		}

		for (int i=0; i<4; i++) {
            jg[njugadas] = new Jugada();
            njugadas += jg[njugadas].genera(mEP, ncjugador, i, nvdado);
	    }

		/* mira si es 5 y sale de casa, en cuyo caso solo hay */
	    /* una jugada permitida */
	    if( nvdado == 5 ) {
	        int saleCasa = -1;
	        for( int i=0; i < njugadas; i++ )
	            if( jg[i].entra ) {
	            	saleCasa = i;
	            	break;
	            }
	        if( saleCasa >= 0 ) {
	            if( saleCasa > 0 ) jg[0] = jg[saleCasa];
	            njugadas = 1;
	        }
	    }
	    /* mira si es 6 o 7 y rompe puente, entonces es obligado */
	    if( nvdado == 6 || nvdado == 7 ) {
	        boolean rpte = false;
	        for( int i=0; !rpte && i < njugadas; i++ )
	            if( jg[i].rpte ) rpte = true;
	        if( rpte ) {
	            int njc = 0;
	            for( int i=0; i<njugadas; i++ ) {
	                if( jg[i].rpte ) jg[njc++] = jg[i];
	            }
	            njugadas = njc;
	        }
	    }
	    return njugadas;
	}
    
	public void completaInfoAnl(EstadoPartida mEP) {
		EstadoPartida ep2 = new EstadoPartida();
		AnlGlobal anlini = new AnlGlobal(mEP);
		GrupoJugadas jpo = new GrupoJugadas();
		for (int i=0; i<njugadas; i++) {
		    int cj = this.jg[i].cjugador;
		    int nf = this.jg[i].nficha;
		    this.jg[i].nficom = anlini.nficom[cj][nf];
		    this.jg[i].nfipel = anlini.nfipel[cj][nf];
			ep2.set(mEP);
			ep2.mTbl.realizaJugada(ep2, this.jg[i]);
			AnlGlobal anlfin = new AnlGlobal(ep2);
		    this.jg[i].nffcom = anlfin.nficom[cj][nf];
		    this.jg[i].nffpel = anlfin.nfipel[cj][nf];
		    this.jg[i].ncfin = 0;
		    if (this.jg[i].destino.lugar == Posicion.CORREDOR) {
		    	int n = this.jg[i].destino.pos;
		    	if (n < Jugada.cent[cj]) n += 67;
		    	this.jg[i].ncfin = n - (17 * cj);
		    }
/*		    if (this.jg[i].come) {
		    	if (jpo.genera(ep2, cj, 20) == 0) this.jg[i].npc = true;
		    }
		    if (this.jg[i].meta) {
		    	if (jpo.genera(ep2, cj, 10) == 0) this.jg[i].npc = true;
		    }*/
		}
	}
}
